precision highp float;

/* default.vert
 * Default vertex shader used when drawing non-mesh objects, such as Framebuffers, Textures, Fonts, etc.
 *
 * @author Matthew DiBernardo [07.27.2023]
 */

attribute vec4 a_position;
attribute vec4 a_color;
attribute vec2 a_texCoord0;
attribute vec3 a_normal;

uniform mat4 u_projTrans;
uniform mat3 u_normalMatrix;

varying vec4 v_color;

uniform sampler2D u_texture;
varying vec2 v_texCoords;
varying vec3 v_normal;


void main() {
    v_color = a_color;
    v_texCoords = a_texCoord0;
    gl_Position = u_projTrans * a_position;
    v_normal = normalize(u_normalMatrix * a_normal);
}